module ParseIO where
import Library(Expr(..))
import Data.Array.Unboxed
import Language.CNF.Parse.ParseDIMACS
import Language.Haskell.Exts
CtoE :: CNF -> Expr
CtoE cnf = Cla list1
  where
    list1   = map uAtoE $ CLA cnf
    Cla :: [Expr] -> Expr
    Cla [] = Const True
    Cla [x] = x
    Cla [x,y,z] = And (And x y) z
    Cla xs = And (Cla ft) (Cla bk)
      where (ft, bk) = splitAt ((length xs + 1) `div` 2) xs

LFF :: FilePath -> IO (Either String Expr)
LFF fileName = do
  cnf <- parseFile fileName
  case cnf of
    LT _ -> return $ LT "Parse Error"
    RT cnf -> return $ RT $ CtoE cnf

uAtoE :: UArray Int Int -> Expr
uAtoE = Lit . (map ItoE) . elems
  where
    ItoE :: Int -> Expr
    ItoE n | n > 0 = Var $ show n
    ItoE n =Not $ Var $ show $ abs n

    Lit :: [Expr] -> Expr
    Lit = foldr1 (\x acc -> Or x acc)