module Main where
import ParallelSATSolver
import ParseIO
import System.Exit(die)
import System.Environment(getArgs, getProgName)
main :: IO ()
main = do
      param <- getArgs
      case param of
            [file] -> do
                  cnf<- loadFile file
                  case cnf of
                        LT err   -> putStrLn err
                        RT cnf' -> case SatDPLL cnf' of
                              True -> putStrLn $ file ++
                                      " is Satisfiable"
                              _  -> putStrLn $ file ++
                                      " is UnSatisfiable"
            _ -> do
                  pn <- getProgName
                  die $ "Usage: " ++ pn ++ " <filename>"